; $5C53 -- PROG-BAS
; 163
(setq basic-tokenz (vector-from-list '(
  `SPECTRUM`
  `PLAY`
  `RND`
  `INKEY$`
  `PI`
  `FN`
  `POINT`
  `SCREEN$`
  `ATTR`
  `AT`
  `TAB`
  `VAL$`
  `CODE`
  `VAL`
  `LEN`
  `SIN`
  `COS`
  `TAN`
  `ASN`
  `ACS`
  `ATN`
  `LN`
  `EXP`
  `INT`
  `SQR`
  `SGN`
  `ABS`
  `PEEK`
  `IN`
  `USR`
  `STR$`
  `CHR$`
  `NOT`
  `BIN`
  `OR`
  `AND`
  `<=`
  `>=`
  `<>`
  `LINE`
  `THEN`
  `TO`
  `STEP`
  `DEF_FN`
  `CAT`
  `FORMAT`
  `MOVE`
  `ERASE`
  `OPEN_#`
  `CLOSE_#`
  `MERGE`
  `VERIFY`
  `BEEP`
  `CIRCLE`
  `INK`
  `PAPER`
  `FLASH`
  `BRIGHT`
  `INVERSE`
  `OVER`
  `OUT`
  `LPRINT`
  `LLIST`
  `STOP`
  `READ`
  `DATA`
  `RESTORE`
  `NEW`
  `BORDER`
  `CONTINUE`
  `DIM`
  `REM`
  `FOR`
  `GO_TO`
  `GO_SUB`
  `INPUT`
  `LOAD`
  `LIST`
  `LET`
  `PAUSE`
  `NEXT`
  `POKE`
  `PRINT`
  `PLOT`
  `RUN`
  `SAVE`
  `RANDOMIZE`
  `IF`
  `CLS`
  `DRAW`
  `CLEAR`
  `RETURN`
  `COPY`
)))

;(lprintln basic-tokenz)
(defun get-basic-num (addr)
  (zxfloat2num (peek-buf (new-bytevector 5) addr))
)

(setq cur-basic-line-num 0)
(setq cur-basic-out-file *f*)

(macro basprint (args | s)
  ;(lprintln "args" args)
  ;(lprintln "args_eval" (eval (car args)))
  ;(setq s (eval (car args)))
  ;(lprintln "args_ev1" s)
  ;(println "_=!"" "!"")
  ;(println "s=!"" s "!"")
  ;(setq s (sprint s))
  ;(setq s (sprint "abc"))
  ;(println "s=!"" s "!"")
  ;(println "args_car " (car args))
  ;(println "args_car_sp" (sprint (eval (car args))))
  ;(setq s *nil*)
  (while args
    ;(setq s (|| s (sprint (car args)))  args (cdr args))
    ;(setq s (sprint (car args))  args (cdr args))
    (setq s (eval (car args))  args (cdr args))
    ;(setq s (sprint s))
    (if (number? cur-basic-out-file)
      (fwrite-str cur-basic-out-file s)
     (print s)
    )
  )
)

(defun show-basic-line (addr from | lnum size b t rv)
; returns line size or -1
  ; number
  ;(if (not (number? from)) (setq from 0))
  (setq lnum (+ (* (peek addr) 256) (peek (incr addr)))  addr (+ addr 2))
  (setq cur-basic-line-num lnum)
  (if (< lnum 10000)
    (begin
      (setq size (+ (* (peek (incr addr)) 256) (peek addr))  addr (+ addr 2))
      (setq rv (if (> size 768) -1 size))
      (if (>= lnum from) (begin
        (basprint lnum " [" size "] ")
        (setq size (min size 768))
        (while (> size 0)
          (setq b (peek addr)  addr (incr addr)  size (decr size))
          ;(basprint b)
          (if
            (= b 14)
              (begin
                (basprint "[N:" (get-basic-num addr) "]")
                (setq addr (+ addr 5)  size (- size 5))
              )
            (< b 32) (basprint "[" b "]")
            (< b 163) (basprint (chr b))
           (basprint (nth basic-tokenz (- b 163)) " ")
          )
        )
        (basprint "\v")
      ))
      rv
    )
   (begin (basprint "not a basic!!" "\v") -1)
  )
)

(defun show-basic (from | addr sz count)
  (if (not (number? from)) (setq from 0))
  (setq addr (+ (* (peek $5C54) 256) (peek $5C53))  count 50)
  (while (land (> count 0) (>= (setq sz (show-basic-line addr from)) 0))
    (setq addr (+ (+ addr sz) 4)
          count (- count (if (>= cur-basic-line-num from) 1 0))
    )
  )
)

(defun show-basic-next ()
  (show-basic (incr cur-basic-line-num))
)

(defun save-basic (fname | addr sz)
  (setq cur-basic-out-file (fopen fname "c"))
  (if (not cur-basic-out-file) (throw "shit!"))

  (setq addr (+ (* (peek $5C54) 256) (peek $5C53)))
  (while (> (setq sz (show-basic-line addr 0)) 0)
    (setq addr (+ (+ addr sz) 4))
  )
  (fclose cur-basic-out-file)
  (setq cur-basic-out-file *f*)
)
