;(setq lasm_argf *t*)
;  ,      . . tech.txt

;    
(setq arg-type 0)    ;   
(setq arg-val 0)     ;  ""    
(setq arg-idxreg 0)  ;     . . arg-idx-XX
(setq arg-memref *f*);  --   ?
(setq asmexpr-addr *f*)
  ; ,    *t* asm-get-label(),   


; 
(setq argf-unknown 0)

(setq argf-cond 1)    ; 
  ;   arg-val:
  (setq argc-nz 0)
  (setq argc-z 1)
  (setq argc-nc 2)
  (setq argc-c 3)
  (setq argc-po 4)
  (setq argc-pe 5)
  (setq argc-p 6)
  (setq argc-m 7)

(setq argf-reg8 2)
  ;   arg-val:
  (setq argr8-b 0)
  (setq argr8-c 1)
  (setq argr8-d 2)
  (setq argr8-e 3)
  (setq argr8-h 4)
  (setq argr8-l 5)
  (setq argr8-mem 6)  ; never sets by the interpreter
  (setq argr8-a 7)

(setq argf-reg16 3)
  ;   arg-val:
  (setq argr16-bc 0)
  (setq argr16-de 1)
  (setq argr16-hl 2)
  (setq argr16-af 3)
  (setq argr16-sp 4)
  (setq argr16-afx 5)
  (setq argr16-ix 6)
  (setq argr16-iy 7)

(setq argf-mem 4)     ; (xx)
  ;   arg-val:
  (setq argm-hl 0)
  (setq argm-bc 1)
  (setq argm-de 2)
  (setq argm-sp 3)

(setq argf-memc 5)  ; (c)

(setq argf-memidx 7)   ; (i?+n), n  arg-val
  ;   arg-idxreg:
  (setq arg-idx-none 0)
  (setq arg-idx-ix $DD)
  (setq arg-idx-iy $FD)

(setq argf-number 6)  ;   arg-val

(setq argf-str 7)     ;   arg-val ( 2- )

(setq argf-regi 8)    ; I
(setq argf-regr 9)    ; R
(setq argf-reg8i 10)  ; HX,LX,HY,LY


;   (      )
;  *nil*,      
(defun asm-arg-test-literal (arg)
  ;  
  (setq arg-type argf-unknown  arg-val 0  arg-idxreg arg-idx-none  arg-memref *f*)

  ;     
  (switch arg
    ;    ,     ,
    ;     
    "nz" (setq arg-type argf-cond  arg-val argc-nz)
    "z" (setq arg-type argf-cond  arg-val argc-z)
    "nc" (setq arg-type argf-cond  arg-val argc-nc)
    "po" (setq arg-type argf-cond  arg-val argc-po)
    "pe" (setq arg-type argf-cond  arg-val argc-pe)
    "p" (setq arg-type argf-cond  arg-val argc-p)
    "m" (setq arg-type argf-cond  arg-val argc-m)
    ;
    "i" (setq arg-type argf-regi)
    "r" (setq arg-type argf-regr)
    ; reg8
    "a" (setq arg-type argf-reg8  arg-val argr8-a)
    "b" (setq arg-type argf-reg8  arg-val argr8-b)
    "c" (setq arg-type argf-reg8  arg-val argr8-c)
    "d" (setq arg-type argf-reg8  arg-val argr8-d)
    "e" (setq arg-type argf-reg8  arg-val argr8-e)
    "h" (setq arg-type argf-reg8  arg-val argr8-h)
    "l" (setq arg-type argf-reg8  arg-val argr8-l)
    ;
    "hx" (setq arg-type argf-reg8i  arg-val argr8-h  arg-idxreg arg-idx-ix)
    "lx" (setq arg-type argf-reg8i  arg-val argr8-l  arg-idxreg arg-idx-ix)
    "hy" (setq arg-type argf-reg8i  arg-val argr8-h  arg-idxreg arg-idx-iy)
    "ly" (setq arg-type argf-reg8i  arg-val argr8-l  arg-idxreg arg-idx-iy)
    "xh" (setq arg-type argf-reg8i  arg-val argr8-h  arg-idxreg arg-idx-ix)
    "xl" (setq arg-type argf-reg8i  arg-val argr8-l  arg-idxreg arg-idx-ix)
    "yh" (setq arg-type argf-reg8i  arg-val argr8-h  arg-idxreg arg-idx-iy)
    "yl" (setq arg-type argf-reg8i  arg-val argr8-l  arg-idxreg arg-idx-iy)
    ; reg16
    "bc" (setq arg-type argf-reg16  arg-val argr16-bc)
    "de" (setq arg-type argf-reg16  arg-val argr16-de)
    "hl" (setq arg-type argf-reg16  arg-val argr16-hl)
    "af" (setq arg-type argf-reg16  arg-val argr16-af)
    "sp" (setq arg-type argf-reg16  arg-val argr16-sp)
    "af'" (setq arg-type argf-reg16  arg-val argr16-afx)
    "ix" (setq arg-type argf-reg16  arg-val argr16-ix)
    "iy" (setq arg-type argf-reg16  arg-val argr16-iy)
    ; mem
    "(bc)" (setq arg-type argf-mem  arg-val argm-bc)
    "(de)" (setq arg-type argf-mem  arg-val argm-de)
    "(hl)" (setq arg-type argf-mem  arg-val argm-hl)
    "(sp)" (setq arg-type argf-mem  arg-val argm-sp)
    ;    (ix)  (iy)
    "(ix)" (setq arg-type argf-memidx  arg-val 0  arg-idxreg arg-idx-ix)
    "(iy)" (setq arg-type argf-memidx  arg-val 0  arg-idxreg arg-idx-iy)
    ; memc
    "(c)" (setq arg-type argf-memc)
  )
)

;    (   "c"    %-( )
(defun asm-arg-interpret-cond (arg)
  (switch arg
    "nz" (setq arg-type argf-cond  arg-val argc-nz)
    "z" (setq arg-type argf-cond  arg-val argc-z)
    "nc" (setq arg-type argf-cond  arg-val argc-nc)
    "c" (setq arg-type argf-cond  arg-val argc-c)
    "po" (setq arg-type argf-cond  arg-val argc-po)
    "pe" (setq arg-type argf-cond  arg-val argc-pe)
    "p" (setq arg-type argf-cond  arg-val argc-p)
    "m" (setq arg-type argf-cond  arg-val argc-m)
    ;  
    (setq arg-type argf-unknown)
  )
)

;  . arg     
(defun asm-arg-interpret (arg | ic ipm)
  (if (not (asm-arg-test-literal arg))
    (begin
      ;   .   ,  ,  (i?<+|->...)
      ; (i?<+|->...)?
      (setq ic (nth arg 3)  ipm (nth arg 4))
      (if
        (land (> (length arg) 5)
              (= (str-mid arg 1 2) "(i")  (= (nth arg -1) 41)
              (lor (= ic 120) (= ic 121))
              (lor (= ipm 43) (= ipm 45))
        )
          (begin
            ; (i?<+|->...)
            (setq arg-type argf-memidx
                  arg-idxreg (if (eq ic 120) arg-idx-ix  arg-idx-iy)
            )
            (setq arg-val (eval (expr-prefix (str-mid arg 4 (- (length arg) 4)))))
            (if (not (within arg-val -128 127))
              (bad-syntax (|| "invalid index: " (tostr arg-val)))
            )
          )
       ; 
       (begin
         ;  . asm-get-label()  
         ;  asmexpr-addr,   "" 
         (setq asmexpr-addr *f*)

         (setq arg-memref
           (land (> (length arg) 2)
                 (= (nth arg 1) 40) (= (nth arg -1) 41)
           )
         )

         (setq arg-val (expr-prefix arg))
         ;(lprintln "imm" arg "val" arg-val)

         (if
           (string? arg-val) ; ,    
             (setq arg-val (str-mid arg-val 2 (- (length arg-val) 2))
                   arg-type argf-str
             )
          ;   ,   . ,  
          (setq arg-type argf-number  arg-val (eval arg-val))
         )
       )
      )
    )
  )
)
